diff --git a/plugins/artwork/artwork.c b/plugins/artwork/artwork.c
index 44df9a0b20..c657200e8e 100644
--- a/plugins/artwork/artwork.c
+++ b/plugins/artwork/artwork.c
@@ -1655,12 +1655,14 @@ path_more_recent (const char *fname, const time_t placeholder_mtime)
 }
 
 static int
-recheck_missing_artwork (char *fname, const time_t placeholder_mtime)
+recheck_missing_artwork (const char *input_fname, const time_t placeholder_mtime)
 {
+    int res = 0;
+    char *fname = strdup (input_fname);
     /* Check if local files could have new associated artwork */
     if (deadbeef->is_local_file (fname)) {
         char *vfs_fname = vfs_path (fname);
-        char *real_fname = vfs_fname ? vfs_fname : fname;
+        const char *real_fname = vfs_fname ? vfs_fname : fname;
 
         /* Recheck artwork if file (track or VFS container) was modified since the last check */
         if (path_more_recent (real_fname, placeholder_mtime)) {
@@ -1668,12 +1670,13 @@ recheck_missing_artwork (char *fname, const time_t placeholder_mtime)
         }
 
         /* Recheck local artwork if the directory contents have changed */
-        if (artwork_enable_local && path_more_recent (dirname (real_fname), placeholder_mtime)) {
-            return 1;
-        }
+        char *dname = strdup (dirname (fname));
+        res = artwork_enable_local && path_more_recent (dname, placeholder_mtime);
+        free (dname);
     }
 
-    return 0;
+    free (fname);
+    return res;
 }
 
 static int
@@ -1690,13 +1693,9 @@ process_query (const cover_query_t *query)
     /* Flood control, don't retry missing artwork for an hour unless something changes */
     struct stat placeholder_stat;
     if (!stat (cache_path, &placeholder_stat) && placeholder_stat.st_mtime + 60*60 > time (NULL)) {
-        char *fname_copy = strdup (query->fname);
-        if (fname_copy) {
-            int recheck = recheck_missing_artwork (fname_copy, placeholder_stat.st_mtime);
-            free (fname_copy);
-            if (!recheck) {
-                return 0;
-            }
+        int recheck = recheck_missing_artwork (fname, placeholder_stat.st_mtime);
+        if (!recheck) {
+            return 0;
         }
     }
 
diff --git a/plugins/artwork/artwork_internal.c b/plugins/artwork/artwork_internal.c
index 719711a108..f035d3ddc4 100644
--- a/plugins/artwork/artwork_internal.c
+++ b/plugins/artwork/artwork_internal.c
@@ -109,28 +109,31 @@ check_dir (const char *path)
         return 0;
     }
 
-    char* dir = strdup (path);
-    if (!dir) {
-        return 0;
-    }
-
-    int good_dir = check_dir (dirname (dir));
+    char *dir = strdup (path);
+    char *dname = strdup (dirname (dir));
+    int good_dir = check_dir (dname);
     free (dir);
+    free (dname);
     return good_dir && !mkdir (path, 0755);
 }
 
-int ensure_dir (const char *path)
-{
-    char dir[PATH_MAX];
-    strcpy (dir, path);
-    char *dname = dirname (dir);
+// check if directory of a supplied file exists,
+// attempt to create one if it doesn't,
+// return 1 on success.
+int
+ensure_dir (const char *path) {
+    char *dir = strdup (path);
+    char *dname = strdup (dirname (dir));
     trace ("artwork: ensure folder %s exists\n", dname);
-    return check_dir (dname);
+    int res = check_dir (dname);
+    free (dir);
+    free (dname);
+    return res;
 }
 
 #define BUFFER_SIZE 4096
-int copy_file (const char *in, const char *out)
-{
+int
+copy_file (const char *in, const char *out) {
     trace ("copying %s to %s\n", in, out);
 
     if (!ensure_dir (out)) {
@@ -153,16 +156,12 @@ int copy_file (const char *in, const char *out)
     }
 
     int err = 0;
-    int bytes_read;
+    int64_t bytes_read;
     size_t file_bytes = 0;
     do {
         char buffer[BUFFER_SIZE];
         bytes_read = deadbeef->fread (buffer, 1, BUFFER_SIZE, request);
-        if (bytes_read < 0 || errno) {
-            trace ("artwork: failed to read file %s: %s\n", tmp_out, strerror (errno));
-            err = -1;
-        }
-        else if (bytes_read > 0 && fwrite (buffer, bytes_read, 1, fout) != 1) {
+        if (bytes_read > 0 && fwrite (buffer, bytes_read, 1, fout) != 1) {
             trace ("artwork: failed to write file %s: %s\n", tmp_out, strerror (errno));
             err = -1;
         }
